<template>
  <div data-component="breadcrumbs">
    <v-list
      one-line
      class="breadcrumbs-list"
    >
      <template v-for="(item, index) in paths">
        <v-list-tile
          :key="index"
          avatar
          class="breadcrumb-item"
        >
          <v-list-tile-content>
            <v-btn
              flat
              :class="getTriggerClass(index)"
              :to="item.url"
            >
              {{ item.name }}
            </v-btn>
          </v-list-tile-content>
        </v-list-tile>
      </template>
    </v-list>
  </div>
</template>

<script>
  import { titlize, isNum, parseToType } from '../utils';

  export default {
    data() {
      return {
        paths: []
      };
    },
    created() {
      this.paths = this.getPaths(this.$route.path);
    },
    methods: {
      getPaths(path) {
        const splitPaths = path.split('/').filter(item => item !== '');

        return splitPaths.map((path, index) => ({
          name: this.getPathName(path),
          url: `/${splitPaths.slice(0, index + 1).join('/')}`
        }));
      },
      getPathName(path) {
        return isNum(parseToType(path)) ? 'Details' : titlize(path);
      },
      getTriggerClass(index) {
        return {
          active: index === this.paths.length - 1
        };
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../assets/stylus/theme.styl';

  [data-component="breadcrumbs"] {
    .breadcrumbs-list {
      background-color: transparent;
      margin-left: -10px;

      .breadcrumb-item {
        display: inline-block;
        position: relative;

        .v-btn {
          min-width: 50px;
          height: auto;
          border-radius: 4px;
          padding: 4px 8px;

          &:before {
            padding: 4px 8px;
            background-color: transparent;
          }

          &.active {
            color: $colors.primary;
          }
        }

        &:first-child {
          .v-list__tile {
            padding-left: 5px !important;
          }

          .v-btn {
            margin: 0;
          }
        }

        &:not(:last-child) {
          &:after {
            content: '/';
            position: absolute;
            top: 14px;
            right: -8px;
            font-size: 18px;
            color: $colors.grey.base;
          }
        }
      }
    }
  }
</style>
